enum Attrs {A_REVERSE,A_NORMAL,A_XOR,A_SHADED,A_REPLACE,A_OR,A_AND,A_THICK1,
            A_SHADE_V,A_SHADE_H,A_SHADE_NS,A_SHADE_PS};

#define ASM_SWAP(val) ({\
    register unsigned long tmp = val;\
    asm volatile ("swap %0" : "=d" (tmp) : "0" (tmp));\
    tmp;})


/*===========================================================================*/
/* draws a horizontal line from (x1,y) to (x2,y) in given plane              */
/*                                                                           */
/* valid modes: A_REPLACE,A_NORMAL,A_REVERSE,A_XOR                           */
/*===========================================================================*/
void FastDrawHLine(unsigned char* plane,short x1,short x2,short y,short mode) {
    static const unsigned short table1[16] = {0xffff,0x7fff,0x3fff,0x1fff,
                                              0x0fff,0x07ff,0x03ff,0x01ff,
                                              0x00ff,0x007f,0x003f,0x001f,
                                              0x000f,0x0007,0x0003,0x0001};
    static const unsigned short table2[16] = {0x0000,0x8000,0xc000,0xe000,
                                              0xf000,0xf800,0xfc00,0xfe00,
                                              0xff00,0xff80,0xffc0,0xffe0,
                                              0xfff0,0xfff8,0xfffc,0xfffe};
    short           dx;
    short           sx;
    unsigned short* p;

    if (x1>x2) {
        short tmp = x1;
        x1 = x2;
        x2 = tmp;
    }

    p  = (unsigned short*)(plane+(y<<5)-(y<<1)+((x1>>3)&0x1e));
    dx = x2-x1+1;
    sx = x1 & 0x000f;

    if (dx<16) {
        unsigned long val = (ASM_SWAP(table2[dx])) >> sx;
        if (mode == A_REPLACE || mode == A_NORMAL) {
            *(unsigned long*)p |= val;
        }
        else if (mode == A_REVERSE) {
            *(unsigned long*)p &= ~val;
        }
        else if (mode == A_XOR) {
            *(unsigned long*)p ^= val;
        }
        return;
    }

    if (mode == A_REPLACE || mode == A_NORMAL) {
        if (sx) {
            *p++ |= table1[sx];
            dx -= (16-sx);
        }
        while (dx >= 16) {
            *p++ |= 0xffff;
            dx-=16;
        }
        if (dx) *p |= table2[dx];
    }
    else if (mode == A_REVERSE) {
        if (sx) {
            *p++ &= ~(table1[sx]);
            dx -= (16-sx);
        }
        while (dx >= 16) {
            *p++ &= 0x0;
            dx-=16;
        }
        if (dx) *p &= ~(table2[dx]);
    }
    else if (mode == A_XOR) {
        if (sx) {
            *p++ ^= table1[sx];
            dx -= (16-sx);
        }
        while (dx >= 16) {
            *p++ ^= 0xffff;
            dx-=16;
        }
        if (dx) *p ^= table2[dx];
    }
}
