| void FastDrawVLine(unsigned char* plane,short x,short y1,short y2,short mode) // C prototype
|
| valid modes: A_REVERSE, A_NORMAL, A_XOR
|
|------------------------------------------------------------------------------
|This routine uses a very dirty trick to combine 3 loops into one.
| This trick is called in-memory-patching. Normally each loop has
| to execute one of the following ASM instructions:
|
| bset %d2,(%a0) ... 0x05d0
| bclr %d2,(%a0) ... 0x0590
| bchg %d2,(%a0) ... 0x0550
|
| As you may note the opcodes are almost identically. There is just
| one byte different (the second byte) and depending on the given mode
| the routine will set this byte BEFORE entering the loop
|------------------------------------------------------------------------------
|
| NOTE: The given mode will not be checked. If the user supplies a wrong mode
|       number the routine won't care about it. It will use A_OR for all other
|       settings.


.data
.globl FastDrawVLine
.even
FastDrawVLine:
       movem.l %a0/%d0-%d2,-(%a7)
       lea    patch,%a0
       move.b #0x90,%d0
       cmpi.w #0,30(%sp)     |is it AND?
       beq.s  next
       move.b #0x50,%d0
       cmpi.w #2,30(%sp)     |is it XOR?
       beq.s  next
       move.b #0xd0,%d0      | no its an OR!
next:  move.b %d0,(%a0)      | patch memory with corresponding byte
       move.w  26(%sp),%d0   |
       move.w  28(%sp),%d1   |
       cmp.w   %d0,%d1       | swap y values if necessary
       bge.s   skip
       exg     %d0,%d1
skip:  sub.w   %d0,%d1       | d1 = abs(y1-y2)
       add.w   %d0,%d0       |
       movea.w %d0,%a0       |
       lsl.w   #4,%d0        |
       sub.w   %a0,%d0       | d0 = 2*abs(y1-y2)*16-2*abs(y1-y2) = 30 * height_in_pixels
       movea.w %d0,%a0
       adda.l  20(%sp),%a0
       move.w  24(%sp),%d0
       move.w  %d0,%d2
       lsr.w   #3,%d0
       adda.l  %d0,%a0       | a0 = 30 * height_in_pixels + plane + (x>>3)
       and.w   #0x7,%d2      | mask out the reqired bit
inner: dc.b    0x05          | one of bchg/bclr/bset %d2,(%a0)
patch: dc.b    0x50
       adda.l  #30,%a0
       dbf     %d1,inner
       bchg %d0,(%a0)
       movem.l (%a7)+,%a0/%d0-%d2
       rts
