/* Generic Sprite Scaling routine
 * by Jim Haskell
 * email: jimhaskell@yahoo.com
 * ICQ: 7448076
 *
 * Copyleft: The usual. This program was released as and should stay open-source.
 *           Feel free to edit/delete/add to these routines as you wish, just give
 *             me credit for the original work. If you do anything spectacular to
 *             increase the speed, please let me know.
 *           If you want to use it to make money, talk to me and get permission.
 *           If this program crashes or other bad things happens to your calculator,
 *             then you are SOL. It's not my fault.
 *
 * [modified and integrated into ExtGraph library by thomas.nussbaumer@gmx.net]
 */

#define getpixel32(s,x,y)  *((unsigned char *)(s)+((y)<<2)+((x)>>3))&bit_table[(x)&7]

void ScaleSprite32_AND(unsigned long *sprite,unsigned char *dest,short x0,short y0,short sizex,short sizey) {
    short x,y;
    unsigned short u,v=0,du=(32<<8)/sizex,dv=(32<<8)/sizey,tempv,pix32,pixscreen;
    unsigned char *src,mask,tempx0=x0>>3,origmask=0x80>>(x0&7);
    static const unsigned char bit_table[8]={128,64,32,16,8,4,2,1};

    for (y=y0;y<y0+sizey;y++) {
        u=0;
        src=((unsigned char *)dest)+(y<<5)-(y<<1)+(tempx0);
        mask=origmask;
        tempv=v>>8;
        for (x=0;x<sizex;x++) {
            pix32=getpixel32(sprite,u>>8,tempv);
            pixscreen=*src&mask;

            if (pix32&&pixscreen) *src|=mask;
            else if (!pix32) *src&=~mask;
            asm("ror.b #1,%0;bcc.s 0f;addq.l #1,%1;0:":"=d" (mask),"=g" (src):"0"(mask),"1"(src));
            u+=du;
        }
        v+=dv;
    }
}
