void GraySpriteX8_MASK(short x,short y,short h,
                       unsigned char* sprite1,
                       unsigned char* sprite2,
                       unsigned char* mask1,
                       unsigned char* mask2,
                       short bytewidth,
                       void* dest1,
                       void* dest2)
{
    register long           offset = (y<<5)-(y<<1)+(x>>3);
    register unsigned char* addr1  = ((unsigned char*)dest1)+offset;
    register unsigned char* addr2  = ((unsigned char*)dest2)+offset;
    register unsigned short shift1 = x & 7;
    register unsigned short shift2;
    register unsigned short lineoffset = 30-bytewidth;
    register          short loop;
    register unsigned char  startmask;
    register unsigned char  endmask;

    if (shift1) {
        shift2 = 8 - shift1;
        startmask = 0xff << shift2;
        endmask   = 0xff >> shift1;
        for (;h;h--,addr1+=lineoffset,addr2+=lineoffset) {
            *addr1   &= ((*mask1) >> shift1) | startmask;
            *addr1++ |= *sprite1 >> shift1;
            *addr2   &= ((*mask2) >> shift1) | startmask;
            *addr2++ |= *sprite2 >> shift1;
            for (loop=1;loop<bytewidth;loop++) {
               unsigned char val = (*mask1++) << shift2;
               *addr1   &= val | ((*mask1) >> shift1);
               *addr1   |= ((*sprite1++) << shift2);
               *addr1++ |= (*sprite1 >> shift1);
               val = (*mask2++) << shift2;
               *addr2   &= val | ((*mask2) >> shift1);
               *addr2   |= ((*sprite2++) << shift2);
               *addr2++ |= (*sprite2 >> shift1);
            }
            *addr1 &= ((*mask1++) << shift2) | endmask;
            *addr1 |= (*sprite1++ << shift2);
            *addr2 &= ((*mask2++) << shift2) | endmask;
            *addr2 |= (*sprite2++ << shift2);
        }
    }
    else {
        for (;h;h--,addr1+=lineoffset,addr2+=lineoffset) {
            for (loop=0;loop<bytewidth;loop++) {
                *addr1   &= *mask1++;
                *addr1++ |= *sprite1++;
                *addr2   &= *mask2++;
                *addr2++ |= *sprite2++;
            }
        }
    }
}
